package ru.dbotthepony.mc.otm.client.render

private fun makeButton(grid: SkinGrid): StretchingRectangleElement {
	val x = grid.currentX
	val y = grid.currentY

	return StretchingRectangleElement(
		topLeft = WidgetLocation.WIDGETS_18.element(x, y, 2f, 2f, grid.imageWidth, grid.imageHeight),
		topRight = WidgetLocation.WIDGETS_18.element(x + 16f, y, 2f, 2f, grid.imageWidth, grid.imageHeight),
		bottomLeft = WidgetLocation.WIDGETS_18.element(x, y + 16f, 2f, 2f, grid.imageWidth, grid.imageHeight),
		bottomRight = WidgetLocation.WIDGETS_18.element(x + 16f, y + 16f, 2f, 2f, grid.imageWidth, grid.imageHeight),
		middle = WidgetLocation.WIDGETS_18.element(x + 2f, y + 2f, 14f, 14f, grid.imageWidth, grid.imageHeight),
		top = WidgetLocation.WIDGETS_18.element(x + 2f, y, 14f, 2f, grid.imageWidth, grid.imageHeight),
		left = WidgetLocation.WIDGETS_18.element(x, y + 2f, 2f, 14f, grid.imageWidth, grid.imageHeight),
		right = WidgetLocation.WIDGETS_18.element(x + 16f, y + 2f, 2f, 14f, grid.imageWidth, grid.imageHeight),
		bottom = WidgetLocation.WIDGETS_18.element(x + 2f, y + 16f, 14f, 2f, grid.imageWidth, grid.imageHeight),
	)
}

object Widgets18 {
	val GRID = SkinGrid(WidgetLocation.WIDGETS_18, 18f, 18f)

	val BUTTON_IDLE_STRETCHABLE = makeButton(GRID)
	val BUTTON_IDLE = GRID.next()
	val BUTTON_HOVERED_STRETCHABLE = makeButton(GRID)
	val BUTTON_HOVERED = GRID.next()
	val BUTTON_PRESSED_STRETCHABLE = makeButton(GRID)
	val BUTTON_PRESSED = GRID.next()
	val ARROW_DOWN = GRID.next()
	val AZ = GRID.next()
	val COUNT = GRID.next()
	val COLON = GRID.next()
	val C = GRID.next()
	val CROSS = GRID.next()
	val FORWARD_SLASH = GRID.next()
	val BATTERY_SLOT_BACKGROUND = GRID.next()
	val PATTERN_SLOT_BACKGROUND = GRID.next()
	val EQUIPMENT_BATTERY_SLOT_BACKGROUND = GRID.next()
	val MATTER_CAPACITOR_SLOT_BACKGROUND = GRID.next()
	val RETURN_ARROW_LEFT = GRID.next()

	init {
		GRID.jump()
	}

	val BUTTON_DISABLED_STRETCHABLE = makeButton(GRID)
	val BUTTON_DISABLED = GRID.next()
}
