package ru.dbotthepony.mc.otm.container

import it.unimi.dsi.fastutil.objects.ObjectSpliterator
import it.unimi.dsi.fastutil.objects.ObjectSpliterators
import net.minecraft.world.Container
import net.minecraft.world.item.ItemStack
import java.util.stream.Stream
import java.util.stream.StreamSupport

class ContainerSpliterator(private val container: Container, offset: Int = 0, private val maxPos: Int = container.containerSize) : ObjectSpliterators.AbstractIndexBasedSpliterator<ItemStack>(offset) {
	override fun get(location: Int): ItemStack {
		return container[location]
	}

	override fun getMaxPos(): Int {
		return maxPos
	}

	override fun makeForSplit(pos: Int, maxPos: Int): ObjectSpliterator<ItemStack> {
		return ContainerSpliterator(container, pos, maxPos)
	}
}

fun Container.spliterator() = ContainerSpliterator(this)
fun Container.stream(): Stream<out ItemStack> = StreamSupport.stream(spliterator(), false)
